import gi.*;
import java.io.*;

class LittleLexer extends Lexicon {

	LittleLexer() throws Exception {

		/**
		* Lexical Specification
		*/
		put("A", Lexicon.expression("0|1"));
		put("B", Lexicon.expression("1(01)+"));
		put("C", Lexicon.expression("01*"));
		put("SPACE", Lexicon.expression("[[:space:]]+"));
	}

	public static void main(String[] argv) throws Exception {
		LittleLexer lexicon = new LittleLexer();
		BufferedReader source = new BufferedReader(new InputStreamReader(System.in));

		while (true) {
			Object lookahead = lexicon.grab(source);
			if (lookahead == END_OF_SOURCE) break;
			System.out.println("terminal=" + lookahead + ", word=" + lexicon.word());
		}
	}
}
